#!/usr/bin/perl -w
use strict;


unlink("$ARGV[0]/RTcore.fasta.phr");
unlink("$ARGV[0]/RTcore.fasta.pin");
unlink("$ARGV[0]/RTcore.fasta.pin");
unlink("$ARGV[0]/RTcore.fasta.psq");
	

# je transforme au format fasta
my $command2 = "java -cp $ARGV[0]/readseq.jar run -f 8 -C $ARGV[0]/fichierAlign.txt >&/dev/null";
system($command2);


# je lance les transformations necessaire pour BioNJ
my $command3 = "clearcut -a -P --in=$ARGV[0]/fichierAlign.txt.fasta -m $ARGV[0]/fichierAlign.txt.matrix --out=$ARGV[0]/fichierAlign.txt.temp >&/dev/null";
system($command3);
unlink("$ARGV[0]/fichierAlign.txt");
unlink("$ARGV[0]/fichierAlign.txt.temp");

my @coupe = split(/\//, $ARGV[0]);
my @recoupe = split(/\./, $coupe[scalar(@coupe)-1]);
rename("$ARGV[0]/fichierAlign.txt.fasta", "$ARGV[0]/$recoupe[0].fasta");


my $ligne = "";
my @data = ();
my $comptX = 0;
my $comptY = 0;
my @name = ();

open(IN,"$ARGV[0]/fichierAlign.txt.matrix") or die "ouverture de $ARGV[0]/fichierAlign.txt.matrix impossible DirectTree.pl\n";
$ligne = <IN>;
while( $ligne = <IN> )
{
	chomp($ligne);
	my @coupe = split(/\t/, $ligne);
	if(scalar(@coupe) > 1)
	{
		my @cut = split(/ /, $coupe[1]);
		$comptY  = scalar(@cut);
		for(my $i=0; $i<$comptY; $i++)
		{
			$data[$comptX][$i] = $cut[$i];
		}
	}
	$name[$comptX] = $coupe[0];
	$comptX++;
}
close(IN);



open(OUT,">$ARGV[0]/fichier_BOOTSTRAP_Align.NJ") or die "ouverture de $ARGV[0]/fichier_BOOTSTRAP_Align.NJ impossible DirectTree.pl\n";	
print OUT "   $comptX\n";
for(my $i=0; $i<$comptX; $i++)
{
	print OUT "$name[$i]\n";
	for(my $j=0; $j<=$comptY; $j++)
	{
		if($j < $i)
		{
			print OUT "$data[$i][$j]  ";
		}
		if($j == $i)
		{
			print OUT "0  ";
		}
		if($j > $i)
		{
			print OUT "$data[$j][$i]  ";
		}
	}
	print OUT "\n";
}
close(OUT);
unlink("$ARGV[0]/fichierAlign.txt.matrix");



# je lance maintenant la commande de BIONJ
my $commandBIONJ = "bionj $ARGV[0]/fichier_BOOTSTRAP_Align.NJ $ARGV[0]/TreeBioNJ.txt >&/dev/null";
system($commandBIONJ);
unlink("$ARGV[0]/fichier_BOOTSTRAP_Align.NJ");

# je vais lancer la commande consense
my $commandBOOT = "$ARGV[0]/vconsense.sh $ARGV[0] $ARGV[0]/TreeBioNJ.txt $ARGV[0]/TreeBioNJ_texte.txt $ARGV[0]/TreeBOOTSTRAP.txt >&/dev/null";
system($commandBOOT);
unlink("$ARGV[0]/TreeBioNJ.txt");



