#!/usr/bin/perl -w
use strict;

my $ligne;
my @ligneOUT = ();
my $comptLine = 0;
my @taxon = ();
my $specialAvant = "</FONT><FONT face=\"Courier New\" color=\"#FF0000\" size=4>";
my $speicalApres = "</FONT><FONT face=\"Courier New\" color=\"#000000\" size=4>";


my $nomGroupUser = "";
# je recupere le nom du groupe de la sequence
open(IN,"$ARGV[0]/TREEComparaison.txt") or die "ouverture de $ARGV[0]/TREEComparaison.txt impossible\n";
	$ligne = <IN>;
	chomp($ligne);
	$nomGroupUser = $ligne;
close(IN);


# je corrige un bug de phylip
my $vraiName = $ARGV[2];
if( ($vraiName =~ /\./) || ($vraiName =~ /\_/) )
{
	my @phylip2 = split(//, $vraiName);
	$vraiName = "";
	for(my $i=0; $i<10; $i++)
	{
		if( ($phylip2[$i] eq ".") )
		{
			$vraiName = $vraiName . "_";
		}
		else
		{
			$vraiName = $vraiName . $phylip2[$i];
		}
	}
}


my $comptGroup = 0;
my @nameSeq = ();
my @group = ();
my @espece = ();

# ici je recupere les noms et les groupes du fichier model et les organismes
open(IN,"$ARGV[0]/tableSequence.txt") or die "ouverture de $ARGV[0]/tableSequence.txt impossible\n";
while( $ligne = <IN> )
{
	chomp($ligne);
	my @cut = split(/ /, $ligne);

	$group[$comptGroup] = $cut[1];
	$nameSeq[$comptGroup] = $cut[0];
	$espece[$comptGroup] = $cut[3];
	$comptGroup++
}
close(IN);





# je vais d'abord recupere les informations qui m'interessent
my $interet = 0;
my $comptPremierEspace = 0;
open(OUT,">$ARGV[0]/$ARGV[3].html") or die "ouverture de $ARGV[0]/$ARGV[3].html impossible\n";

open(IN,"$ARGV[0]/TreeBioNJ_texte.txt") or die "ouverture de $ARGV[0]/TreeBioNJ_texte.txt impossible\n";
while( $ligne = <IN> )
{
	chomp($ligne);

	# maintenant je recupere les informations
	if($interet == 1)
	{
		my @coupe = split(//, $ligne);
		my $word = 0;
		$taxon[$comptLine] = "";
		$ligneOUT[$comptLine] = "";
		for(my $i=0; $i<scalar(@coupe); $i++)
		{
			if( ($coupe[$i] eq " ") && ($word == 0) )
			{
				$ligneOUT[$comptLine] = $ligneOUT[$comptLine] . "&nbsp;";
				if($comptLine == 0)
				{
					$comptPremierEspace++;
				}
			}
			elsif( (($coupe[$i] =~ /\d/) || ($coupe[$i] eq ".") || ($coupe[$i] eq "+") || ($coupe[$i] eq "-") || ($coupe[$i] eq "|")) && ($word == 0) )
			{
				$ligneOUT[$comptLine] = $ligneOUT[$comptLine] . "$coupe[$i]";
			}
			elsif( ($coupe[$i] =~ /\D/) && ($word == 0) && ($coupe[$i] ne " ") )
			{
				$ligneOUT[$comptLine] = $ligneOUT[$comptLine] . "&nbsp;";
				$word = 1;
			}

			if($word == 1)
			{
				if($coupe[$i] eq " ")
				{
					$taxon[$comptLine] = $taxon[$comptLine] . "_";
				}
				else
				{
					$taxon[$comptLine] = $taxon[$comptLine] . $coupe[$i];
				}
			}
		}

		if($taxon[$comptLine] eq $ARGV[1])
		{
			$taxon[$comptLine] = $ARGV[2];
		}
		else
		{
			if(length($taxon[$comptLine]) < 10)
			{
				for(my $j=0; $j<$comptGroup; $j++)
				{		
					if($taxon[$comptLine] eq $nameSeq[$j])
					{
						$taxon[$comptLine] = $nameSeq[$j];
						$j = $comptGroup;
					}
				}
			}
			else
			{
				for(my $j=0; $j<$comptGroup; $j++)
				{
					my $exact = 0;
					my @coupe1 = split(//, $taxon[$comptLine]);
					my @coupe2 = split(//, $nameSeq[$j]);

					if(scalar(@coupe2) >= 10)
					{
						for(my $k=0; $k<scalar(@coupe1); $k++)
						{
							if($coupe1[$k] ne $coupe2[$k])
							{
								$exact = 1;
								$k = scalar(@coupe1);
							}
						}
					}
					else
					{
						$exact = 1;
					}
					if($exact == 0)
					{
						$taxon[$comptLine] = $nameSeq[$j];
						$j = $comptGroup;
					}
				}
			}
		}

		$comptLine++;
	}



	if( ($ligne =~ /among the trees, out of /) || ( $ligne =~ /trees had fractional weights/) )
	{
		$interet = 1;
		$ligne = <IN>;
	}

}
close(IN);


my $sizeTaxa = 0;
for(my $i=0; $i<$comptLine; $i++)
{
	if($sizeTaxa < length($taxon[$i]))
	{
		$sizeTaxa = length($taxon[$i]);
	}
}
if( $sizeTaxa < length($ARGV[2]) )
{
	$sizeTaxa = length($ARGV[2]);
}
$sizeTaxa++;



print OUT "\n";
print OUT "<HTML> \n";
print OUT "\t<title>" . $ARGV[3] . "</title> \n";
print OUT "\t<style type=\"text/css\"> \n";
print OUT "\t\t a:link{text-decoration:none} \n";
print OUT "\t\t a:visited{text-decoration:none; color:blue;} \n";
print OUT "\t\t a:active{text-decoration:none} \n";
print OUT "\t\t a:hover{text-decoration:none; color:blue;} \n";
print OUT "\t</style> \n";
print OUT "<BODY> \n";



# rajout du nom au debut du fichier HTML
print OUT "<FONT face=\"Courier New\" color=\"#000000\" size=4>";
print OUT "The sequence ";
print OUT "$specialAvant \n";
print OUT "$ARGV[2] ";
print OUT "$speicalApres \n";
print OUT "belongs to ";
print OUT "$specialAvant \n";
print OUT "$nomGroupUser ";
print OUT "$speicalApres \n";
print OUT "group \n";
print OUT "<BR><BR>\n";


# change la couleur de la font en vert pour le nom des colonnes de l'arbre
print OUT "<FONT face=\"Courier New\" color=\"#00AA00\" size=4>";


my @space = split(/\+/, $ligneOUT[0]);
my @recoupe = split(/\-/, $space[1]);
my $temp22 = scalar(@recoupe);

my $comptspace = $comptPremierEspace + $temp22 + 1;
for(my $j=0; $j<$comptspace; $j++)
{
	print OUT "&nbsp;";
}
print OUT "Families";
my $diffTaille2 = $sizeTaxa - 8;

for(my $j=0; $j<$diffTaille2+6; $j++)
{
	print OUT "&nbsp;";
}
print OUT "Species";
for(my $j=0; $j<10; $j++)
{
	print OUT "&nbsp;";
}
print OUT "Clades\n";
print OUT "$speicalApres";
print OUT "<br>\n";
print OUT "<br>\n";




# j ecris maintenant les informations necesaire 
for(my $i=0; $i<$comptLine; $i++)
{
	# imprime la ligne de l'arbre
	print OUT "$ligneOUT[$i]";

	# ajoute de la couleur si c'est le nouveau taxon
	if( ($taxon[$i] eq $ARGV[2]) || ($taxon[$i] eq $vraiName) )
	{
		$taxon[$i] = $ARGV[2];
		print OUT "$specialAvant";
		print OUT "$taxon[$i]";
		print OUT "$speicalApres";
	}
	else
	{
		print OUT "$taxon[$i]";
	}

	# ajoute des espaces pour que tous les taxons aient la meme longueur
	my $diffTaille = $sizeTaxa - length($taxon[$i]);
	for(my $j=0; $j<$diffTaille; $j++)
	{
		print OUT "&nbsp;";
	}
	for(my $j=0; $j<6; $j++)
	{
		print OUT "&nbsp;";
	}


	# ajoute le nom du groupe auquel il appartient
	if( ($taxon[$i] ne $ARGV[2]) && ($taxon[$i] ne $vraiName) )
	{
		if($taxon[$i] ne $ARGV[2])
		{
			for(my $j=0; $j<$comptGroup; $j++)
			{		
				if($taxon[$i] eq $nameSeq[$j])
				{
					print OUT "$espece[$j]";
					my $tailleSpecie = 12 - length($espece[$j]);
					for(my $j=0; $j<$tailleSpecie; $j++)
					{
						print OUT "&nbsp;";
					}
					
					for(my $j=0; $j<6; $j++)
					{
						print OUT "&nbsp;";
					}

					print OUT "$group[$j]";
					$j = $comptGroup;
				}
			}
		}
	}
	else
	{
		for(my $j=0; $j<18; $j++)
		{
			print OUT "&nbsp;";
		}

		print OUT "$specialAvant";
		print OUT "$nomGroupUser";
		print OUT "$speicalApres";
	}

	print OUT "&nbsp;&nbsp;&nbsp;&nbsp; <br>\n";
}

print OUT "</FONT>\n";


# transforme l'arbre en PDF
my $transfoInSVG = "$ARGV[0]/vdendro1.sh $ARGV[0]/TreeBOOTSTRAP.txt $ARGV[0]/SVGfile.svg";
system("$transfoInSVG");
my $dernierTransfo = "inkscape -z -f $ARGV[0]/SVGfile.svg -A $ARGV[0]/$ARGV[3].pdf";
system("$dernierTransfo");


print OUT "\n</BODY>\n";
print OUT "</HTML>\n";
close(OUT);


unlink("$ARGV[0]/RTnonLTR.muscle.dnd");
unlink("$ARGV[0]/RTnonLTR.muscle.mfa");
#unlink("$ARGV[0]/TreeBioNJ_texte.txt");



