#! /usr/bin/perl -w
use strict;
use Thread qw(:DEFAULT async yield);
use threads::shared;
my @threads;
my @args;
share(@args);
while(<>)
{
   chomp;
   push @args, $_;
}

my $CPUs = `cat /proc/cpuinfo | grep "^processor"|wc -l`;
chomp $CPUs;

for(my $i = 0; $i<$CPUs; $i++)
{
	push @threads, async
	{
		my $arg;
		do
		{
			lock(@args);
			$arg = shift @args;
			
			if($arg)
			{
				chomp $arg;
				my $directory = "";
				if(!-e $arg)
				{
				   die "$arg not found";
				}
				else
				{
					my @cut = split(/resultat/, $arg);
					$directory = $cut[0];
				}
				
				my $CMD = "clearcut -a -P --in=$arg -m $arg.matrix --out=$arg.temp >&/dev/null";			
				system($CMD);
				yield();
			}
		} 
		while(@args);
	};
}
foreach my $thread (@threads)
{
	$thread->join;
}

