#!/bin/bash

# This script opens a newick tree in Dendroscope 
# and saves the Dendroscope tree as a SVG immage.
#
# vdendro1.sh <infile> <outfile>
#
# <infile>  - file containing an input tree in the Newick format;
# <outfile> - name of the output file with the SVG image. 
#echo "----- Start of Dendroscope -----"

/usr/bin/xvfb-run -a -f /tmp/.Xauthority.$$ /usr/local/bin/Dendroscope +g false +s false -x "open file=$1" >& /dev/null <<EOF
set drawer=RectangularPhylogram
expand direction=vertical
expand direction=vertical
expand direction=vertical
expand direction=vertical
expand direction=vertical
expand direction=vertical
expand direction=vertical
expand direction=vertical
expand direction=vertical
expand direction=vertical
expand direction=vertical
expand direction=vertical
expand direction=horizontal
expand direction=horizontal
expand direction=horizontal
expand direction=horizontal
expand direction=horizontal
expand direction=horizontal
expand direction=horizontal
expand direction=horizontal
expand direction=horizontal
expand direction=horizontal
expand direction=horizontal
expand direction=horizontal
exportgraphics format=SVG file=$2 replace=true
quit
EOF

/bin/rm /tmp/.Xauthority.$$

#echo "----- End of Dendroscope ------"
